"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAxiosHandler = void 0;
const axios_1 = require("axios");
// config 留着扩展
function createAxiosHandler(config) {
    // eslint-disable-next-line space-before-function-paren
    return function (options) {
        return __awaiter(this, void 0, void 0, function* () {
            const { uri, method, params, headers } = options;
            let requestOptions = Object.assign(Object.assign(Object.assign({}, options), { url: uri, 
                // 请求方法
                method, 
                // 请求参数
                data: params, 
                // 请求头信息
                headers: headers }), config);
            // 处理一下请求时 去掉url params
            const requestTypes = ["POST", "PUT", "PATCH"];
            const __method = method;
            if (requestTypes === null || requestTypes === void 0 ? void 0 : requestTypes.includes(__method)) {
                requestOptions = Object.assign(Object.assign({}, requestOptions), { params: "" });
            }
            return yield (0, axios_1.default)(requestOptions);
        });
    };
}
exports.createAxiosHandler = createAxiosHandler;
