/*
 * @Description  : lowcode-engine axios
 * @Autor        : 杜康
 * @Date         : 2023-10-27 11:11:18 +0800
 * @LastEditors  : 杜康
 * @LastEditTime : 2023-10-27 14:53:39 +0800
 */
import { RuntimeOptionsConfig } from "@alilc/lowcode-datasource-types";
import axios from "axios";
import type { AxiosRequestConfig, AxiosHeaders, AxiosResponse } from "axios";

// config 留着扩展
export function createAxiosHandler(config?: Record<string, unknown>) {
  // eslint-disable-next-line space-before-function-paren
  return async function (options: RuntimeOptionsConfig) {
    const { uri, method, params, headers } = options;
    let requestOptions: AxiosRequestConfig = {
      ...options,
      url: uri,
      // 请求方法
      method,
      // 请求参数
      data: params,
      // 请求头信息
      headers: headers as AxiosHeaders,
      // 在 axiosHandlersMap 控制请求方式对应的发送请求的行为实例设计器时，可丰富扩展传入请求实例的参数
      ...config,
    };
    // 处理一下请求时 去掉url params
    const requestTypes: string[] = ["POST", "PUT", "PATCH"];
    const __method: any = method;
    if (requestTypes?.includes(__method)) {
      requestOptions = { ...requestOptions, params: "" };
    }
    return await axios(requestOptions);
  };
}
